Unit aee4e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AMA1E_p;

procedure aee4e(var A :Array of Extended; var B :Array of Extended;
                N :Integer; var RU :Array of Extended;
                var W :Array of Extended; K :Integer);

implementation

procedure aee4e(var A :Array of Extended; var B :Array of Extended;
                N :Integer; var RU :Array of Extended;
                var W :Array of Extended; K :Integer);
var
I,J,I1,N1,D,E,F,G,O,P1,I2 :Integer;
Q,R,S,T,Z,BC,BD,EPS,WMIN2,HM :Extended;
const
SYS051 :Extended = 1.1107652e-16;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12;
begin
WMIN2 := SYS051;
W[0] := A[0];
if ( N = 1 ) 
 then goto _12;
AMA1E(A,B,N,Q,R,HM,P1);
O := N-K;
for I:=1 to K do
 begin
  W[I-1] := Q;
_1:
  RU[I-1] := R;
 end;
EPS := EMax1(Abs(R),Abs(Q))*WMIN2;
T := 2.0e0*WMIN2;
N1 := 1+K;
for I1:=1 to K do
 begin
  D := N1-I1;
  Q := W[D-1];
  if ( R > RU[D-1] ) 
   then R := RU[D-1];
  I2 := 1+D;
  for E:=1 to D do
   begin
    I := I2-E;
    if ( Q >= W[I-1] ) 
     then goto _2;
    Q := W[I-1];
    goto _3;
_2:
   end;
_3:
  S := (Q+R)*0.5e0;
  if ( R-Q <= (Abs(R)+Abs(Q))*T+EPS ) 
   then goto _9;
  F := 0;
  BC := A[0]-S;
  if ( BC < 0.0e0 ) 
   then F := 1;
  for J:=2 to N do
   begin
    Z := B[J-1];
    if ( BC <> 0.0e0 ) 
     then goto _4;
    BD := Abs(Z)/WMIN2;
    goto _5;
_4:
    BD := (Z/BC)*Z;
_5:
    BC := A[J-1]-S-BD;
    if ( BC < 0.0e0 ) 
     then F := F+1;
_6:
   end;
  F := F-O;
  if ( F >= D ) 
   then goto _8;
  Q := S;
  if ( F >= 1 ) 
   then goto _7;
  W[0] := S;
  goto _3;
_7:
  G := F+1;
  W[G-1] := S;
  if ( RU[F-1] > S ) 
   then RU[F-1] := S;
  goto _3;
_8:
  R := S;
  goto _3;
_9:
  W[D-1] := S;
_10:
 end;
if ( P1 = 0 ) 
 then goto _12;
HM := 1.e0/HM;
for I:=1 to K do
 begin
_11:
  W[I-1] := W[I-1]*HM;
 end;
_12:
end;

end.
